Unit AMMER_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

procedure AMMER(var A :Array of Real; N :Integer; NLA :Integer;
                NUA :Integer; var B :Array of Real; M :Integer;
                var C :Array of Real); 
implementation

procedure AMMER(var A :Array of Real; N :Integer; NLA :Integer;
                NUA :Integer; var B :Array of Real; M :Integer;
                var C :Array of Real);
var
NCC,NLCP1,NLCP2,NMNUC,JC,NC,KK,I,L,IR,K,J :Integer;
SUM :Real;
label
_1,_2,_3;
begin
NCC := NLA+NUA+1;
NLCP1 := NLA+1;
NLCP2 := NLA+2;
NMNUC := N-NUA;
for JC:=1 to M do
 begin
  NC := NCC;
  KK := 1;
  for I:=1 to N do
   begin
    L := NLCP2-I;
    IR := Max0(L,1);
    if ( L <= 0 ) 
     then KK := KK+1;
    K := KK;
    SUM := 0.0;
    for J:=IR to NC do
     begin
      SUM := SUM+A[(I-1)+(J-1)*N]*B[(K-1)+(JC-1)*N];
      K := K+1;
_1:
     end;
    C[(I-1)+(JC-1)*N] := SUM;
    if ( I >= NMNUC ) 
     then NC := NC-1;
_2:
   end;
_3:
 end;
end;

end.
